package Socket::Netlink::Taskstats;
# This module was generated automatically by ExtUtils::H2PM from lib/Socket/Netlink/Taskstats_const.pm.PL

use Carp;
push @EXPORT, 'CMD_UNSPEC', 'CMD_GET', 'CMD_NEW', 'TYPE_PID', 'TYPE_TGID', 'TYPE_STATS', 'TYPE_AGGR_PID', 'TYPE_AGGR_TGID', 'CMD_ATTR_PID', 'CMD_ATTR_TGID', 'CMD_ATTR_REGISTER_CPUMASK', 'CMD_ATTR_DEREGISTER_CPUMASK', 'pack_taskstats', 'unpack_taskstats';
use constant CMD_UNSPEC => 0;
use constant CMD_GET => 1;
use constant CMD_NEW => 2;
use constant TYPE_PID => 1;
use constant TYPE_TGID => 2;
use constant TYPE_STATS => 3;
use constant TYPE_AGGR_PID => 4;
use constant TYPE_AGGR_TGID => 5;
use constant CMD_ATTR_PID => 1;
use constant CMD_ATTR_TGID => 2;
use constant CMD_ATTR_REGISTER_CPUMASK => 3;
use constant CMD_ATTR_DEREGISTER_CPUMASK => 4;

sub pack_taskstats
{
   ref($_[0]) eq "HASH" or croak "usage: pack_taskstats(\%args)";
   my @v = @{$_[0]}{'version', 'ac_exitcode', 'ac_flag', 'ac_nice', 'cpu_count', 'cpu_delay_total', 'blkio_count', 'blkio_delay_total', 'swapin_count', 'swapin_delay_total', 'cpu_run_real_total', 'cpu_run_virtual_total', 'ac_comm', 'ac_sched', 'ac_uid', 'ac_gid', 'ac_pid', 'ac_ppid', 'ac_btime', 'ac_etime', 'ac_utime', 'ac_stime', 'ac_minflt', 'ac_majflt', 'coremem', 'virtmem', 'hiwater_rss', 'hiwater_vm', 'read_char', 'write_char', 'read_syscalls', 'write_syscalls', 'read_bytes', 'write_bytes', 'cancelled_write_bytes', 'nvcsw', 'nivcsw', 'ac_utimescaled', 'ac_stimescaled', 'cpu_scaled_run_real_total', 'freepages_count', 'freepages_delay_total'};
   pack "S xxL C C xxxxxxQ Q Q Q Q Q Q Q Z32 C xxxxxxxL L L L L xxxxQ Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q ", @v;
}

sub unpack_taskstats
{

   my @v = unpack "S xxL C C xxxxxxQ Q Q Q Q Q Q Q Z32 C xxxxxxxL L L L L xxxxQ Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q Q ", $_[0];
   my %ret; @ret{'version', 'ac_exitcode', 'ac_flag', 'ac_nice', 'cpu_count', 'cpu_delay_total', 'blkio_count', 'blkio_delay_total', 'swapin_count', 'swapin_delay_total', 'cpu_run_real_total', 'cpu_run_virtual_total', 'ac_comm', 'ac_sched', 'ac_uid', 'ac_gid', 'ac_pid', 'ac_ppid', 'ac_btime', 'ac_etime', 'ac_utime', 'ac_stime', 'ac_minflt', 'ac_majflt', 'coremem', 'virtmem', 'hiwater_rss', 'hiwater_vm', 'read_char', 'write_char', 'read_syscalls', 'write_syscalls', 'read_bytes', 'write_bytes', 'cancelled_write_bytes', 'nvcsw', 'nivcsw', 'ac_utimescaled', 'ac_stimescaled', 'cpu_scaled_run_real_total', 'freepages_count', 'freepages_delay_total'} = @v;
   \%ret;
}

1;
